
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Api_tokensDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const api_tokens = await db.api_tokens.create(
            {
                id: data.id || undefined,
        
        token_hash: data.token_hash
        ||
        null
            ,
            
        expires_at: data.expires_at
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        last_used_at: data.last_used_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await api_tokens.setApi_client( data.api_client || null, {
            transaction,
        });
        
        await api_tokens.setTenant( data.tenant || null, {
            transaction,
        });
        
        await api_tokens.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return api_tokens;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const api_tokensData = data.map((item, index) => ({
                id: item.id || undefined,
                
                token_hash: item.token_hash
            ||
            null
            ,
            
                expires_at: item.expires_at
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                last_used_at: item.last_used_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const api_tokens = await db.api_tokens.bulkCreate(api_tokensData, { transaction });

        // For each item created, replace relation files
        

        return api_tokens;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const api_tokens = await db.api_tokens.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.token_hash !== undefined) updatePayload.token_hash = data.token_hash;
        
        
        if (data.expires_at !== undefined) updatePayload.expires_at = data.expires_at;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.last_used_at !== undefined) updatePayload.last_used_at = data.last_used_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await api_tokens.update(updatePayload, {transaction});

        
        
        if (data.api_client !== undefined) {
            await api_tokens.setApi_client(
              
              data.api_client,
              
              { transaction }
            );
        }
        
        if (data.tenant !== undefined) {
            await api_tokens.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await api_tokens.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return api_tokens;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const api_tokens = await db.api_tokens.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of api_tokens) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of api_tokens) {
                await record.destroy({transaction});
            }
        });


        return api_tokens;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const api_tokens = await db.api_tokens.findByPk(id, options);

        await api_tokens.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await api_tokens.destroy({
            transaction
        });

        return api_tokens;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const api_tokens = await db.api_tokens.findOne(
            { where },
            { transaction },
        );

        if (!api_tokens) {
            return api_tokens;
        }

        const output = api_tokens.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.api_client = await api_tokens.getApi_client({
            transaction
        });
        
        
        output.tenant = await api_tokens.getTenant({
            transaction
        });
        
        
        output.organizations = await api_tokens.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.api_clients,
        as: 'api_client',
        
        where: filter.api_client ? {
          [Op.or]: [
            { id: { [Op.in]: filter.api_client.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.api_client.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.token_hash) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'api_tokens',
                        'token_hash',
                        filter.token_hash,
                    ),
                };
            }
            

            
            

            
            if (filter.expires_atRange) {
                const [start, end] = filter.expires_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    expires_at: {
                    ...where.expires_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.last_used_atRange) {
                const [start, end] = filter.last_used_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    last_used_at: {
                    ...where.last_used_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    last_used_at: {
                    ...where.last_used_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.api_tokens.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'api_tokens',
                        'token_hash',
                        query,
                    ),
                ],
            };
        }

        const records = await db.api_tokens.findAll({
            attributes: [ 'id', 'token_hash' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['token_hash', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.token_hash,
        }));
    }

    
};

